
;  Kflush.asm       Flush the keyboard.
;     Written by Dave Angel.  Given freely to the public domain,
;     Compuserve  71046,1567    Delphi   DaveA

COMMENT *
   This program was written in order to flush the keyboard after running
   a program in which the user may have activated a long keyboard macro.
   It can be used in a batch file that exec's the program, and then KFLUSH.

   Notice I deliberately didn't use Fct 0C to flush the keyboard since
   I couldn't be sure it was properly implemented in all Bios's.  The
   method used here should work on all MSDOS machines.
*


;  DISCLAIMER --  No claim is made as to compatibility with other programs.
;    The source code is provided so that the recipient may customize as needed.  This program should be loaded
;
code  segment
assume  cs:code, ds:code, es:code

org 100h
main            proc
        jmp     loop3
loop1:  mov     ah,07h
        int     21h             ; get the key and throw it away
loop2:  mov     cx,200
loop3:  mov     ah,0bh
        int     21h             ; check keyboard status
        cmp     al,00
        jne     loop1           ; if there's a key, take it
        loop    loop3           ; test 200 times just to make sure
        mov     ax,4c00h
        int     21h             ; terminate with no error

main    endp
code    ends
end     main

